"use strict";
/* MEGA MENU Javascript utitlity
 * 
 * Author: Martin Zilz, Kreativkonzentrat GbR
 * 
 */

var kkMegaMenu = function(breadcrumb){
	this._init(breadcrumb);
}

kkMegaMenu.prototype = {
	/*
	 * Initialize the Mega Menu Javascript stuff
	 */
	_init: function(breadcrumb){
		var self = this;
		$(function(){
			// Center Items
			self.centerItems();
			$(document).resize(function(){
				self.centerItems();
			});

			// Close Hover on Touch
			$('#page').click(function(){
				// reset touched states
				$('#kk-mega-menu.mobile .touched').removeClass('touched');
			});


			// Touch open / close of Mega Menu
			$('#kk-mega-menu .menu-mobile-opener').bind('click', function(e){
				var menu = $('#kk-mega-menu');
				if(menu.hasClass('touch-open')){
					menu.removeClass('touch-open');
				}else{
					menu.addClass('touch-open');
				}
			});

			// Mobile Touch event prevention
			var mobile = { timeout: null, listener: "click" }

			$('#kk-mega-menu.mobile .menu-top-item.has-dropdown > a').bind(mobile.listener, function(e){
				var self = $(this);
				var menuItem = self.closest('.menu-top-item');
				if(mobile.timeout){
					clearTimeout(mobile.timeout);
				}

				if(!menuItem.hasClass('touched')){
					$('#kk-mega-menu .touched').removeClass('touched');
					menuItem.addClass('touched');
				}else{
					// follow the link
					var link = self.attr('href');
					if(link && link !== ""){
						window.location.href = link;
					}
				}

				e.preventDefault();
				e.stopPropagation();
			});

			// mark active paths
			self.markActivePaths(breadcrumb);
		});
	},
	/*
	 *	Try to get active Links
	 */
	markActivePaths: function(breadcrumb){
	    if(!breadcrumb || !breadcrumb.length) return;
		var isLast = false;
		for(var i=0; i<breadcrumb.length; i++){
			isLast = (i == breadcrumb.length - 1);
			var link = breadcrumb[i].url;
			// loop through all links inside the menu and check if one of it
			// is given inside the breadcrumb object
			$('#kk-mega-menu a[href="' + link + '"]').each(function(){
				var parent = $(this).parent();
				if(isLast){
					if(parent.hasClass('menu-top-item')){
						parent.addClass('active-category');
					}else{
						$(this).addClass('active-category');
					}
				}else{
					if(parent.hasClass('menu-top-item')){
						parent.addClass('active-parent');
					}else{
						$(this).addClass('active-parent');
					}
				}
			});

		}
	},
	centerItems: function(){
		// center items if told to do so
		$('#kk-mega-menu .menu-top-item.menu-center .submenu').each(function(){
			
			$(this).css('left', '0px');
			var left = -1*$(this).outerWidth()/2 + $(this).closest('.menu-top-item').outerWidth()/2;
			var menuLeft = $(this).closest('.menu-top-item').position().left
			
			if(-1*left > menuLeft){
				left = menuLeft * -1;
			}
			
			//var menuWidth = $('#kk-mega-menu').outerWidth();

			if(menuLeft + left + $(this).outerWidth() > $('#kk-mega-menu').outerWidth()){
				var overflow = $('#kk-mega-menu').outerWidth() - (menuLeft + left + $(this).outerWidth());
				left += overflow;
			}
			$(this).css('margin-left', left + 'px');
			$(this).css('left', '');
		});
	}
}